// testView.cpp : CtestView NX̎
//

#include "stdafx.h"
#include "test.h"

#include "testDoc.h"
#include "testView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CtestView

IMPLEMENT_DYNCREATE(CtestView, CView)

BEGIN_MESSAGE_MAP(CtestView, CView)
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_FILE_OPEN, &CtestView::OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE_AS, &CtestView::OnFileSaveAs)
	ON_COMMAND(ID_MONOTONE, &CtestView::OnMonotone)
	ON_COMMAND(ID_FBINARY, &CtestView::OnFbinary)
	ON_COMMAND(ID_CONTOUR, &CtestView::OnContour)
	ON_COMMAND(ID_FPOINT, &CtestView::OnFpoint)
	ON_COMMAND(ID_THINNING, &CtestView::OnThinning)
	ON_COMMAND(ID_TRANSB21, &CtestView::OnTransb21)
	ON_COMMAND(ID_CIRCULARITY, &CtestView::OnCircularity)
	ON_COMMAND(ID_HOUGH, &CtestView::OnHough)
	ON_COMMAND(ID_LAPLACIAN, &CtestView::OnLaplacian)
	ON_COMMAND(ID_ABINARY, &CtestView::OnAbinary)
	ON_COMMAND(ID_SUBTRACTION, &CtestView::OnSubtraction)
	ON_COMMAND(ID_PRODUCT, &CtestView::OnProduct)
	ON_COMMAND(ID_FILE2, &CtestView::OnFile2)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_HSVCONV, &CtestView::OnHsvconv)
	ON_COMMAND(ID_CSEG, &CtestView::OnCseg)
	ON_COMMAND(ID_MERGE, &CtestView::OnMerge)
	ON_COMMAND(ID_ULEFT, &CtestView::OnUleft)
	ON_COMMAND(ID_LRIGHT, &CtestView::OnLright)
	ON_COMMAND(ID_CUT, &CtestView::OnCut)
	ON_COMMAND(ID_PATMATCH, &CtestView::OnPatmatch)
	ON_COMMAND(ID_LAPLACIAN2, &CtestView::OnLaplacian2)
	ON_COMMAND(ID_LAPLACIAN3, &CtestView::OnLaplacian3)
	ON_COMMAND(ID_DERIVATIVE, &CtestView::OnDerivative)
	ON_COMMAND(ID_AVERAGE, &CtestView::OnAverage)
	ON_COMMAND(ID_PREWITT, &CtestView::OnPrewitt)
	ON_COMMAND(ID_SOBEL, &CtestView::OnSobel)
	ON_COMMAND(ID_MEDIAN, &CtestView::OnMedian)
	ON_COMMAND(ID_SHARPEN, &CtestView::OnSharpen)
	ON_COMMAND(ID_CONTOURL, &CtestView::OnContourl)
	ON_COMMAND(ID_BLABELING, &CtestView::OnBlabeling)
	ON_COMMAND(ID_NEGATIVE, &CtestView::OnNegative)
	ON_COMMAND(ID_SEPIA, &CtestView::OnSepia)
	ON_COMMAND(ID_DERESOL, &CtestView::OnDeresol)
	ON_COMMAND(ID_FILLING, &CtestView::OnFilling)
	ON_COMMAND(ID_EPOINT, &CtestView::OnEpoint)
	ON_COMMAND(ID_SEQUEL, &CtestView::OnSequel)
	ON_COMMAND(ID_PRESS, &CtestView::OnPress)
	ON_COMMAND(ID_SKIN, &CtestView::OnSkin)
	ON_COMMAND(ID_TRANS31, &CtestView::OnTrans31)
	ON_COMMAND(ID_TRANS01, &CtestView::OnTrans01)
	ON_COMMAND(ID_DISP1, &CtestView::OnDisp1)
	ON_COMMAND(ID_DISP2, &CtestView::OnDisp2)
	ON_COMMAND(ID_DISP3, &CtestView::OnDisp3)
	ON_COMMAND(ID_HEXTRACT, &CtestView::OnHextract)
	ON_COMMAND(ID_TFINGER, &CtestView::OnTfinger)
END_MESSAGE_MAP()

// CtestView RXgNV/fXgNV

CtestView::CtestView() //ݒ
{
	// TODO: \zR[hɒǉ܂B

	jpgLoadFlag1=false;				//摜̕\sȂ
									//(̓͋Ȃ̂Łj
	jpgLoadFlag2=false;
	jpgLoadFlag3=false;
	LabFlag=false;					//xÖ搔\tO
	FPFlag=false;					//_\tO
	SquareS();						//R~R`pCfbNX̎s
	SquareS2();						//V~VߖTpCfbNX
	Color();						//gpF̒`
	HSVFlag=false;					//HSVϊ\
	SegFlag=false;					//F̈敪\tO
}

CtestView::~CtestView()
{
}

BOOL CtestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CView::PreCreateWindow(cs);
}

// CtestView `

void CtestView::OnDraw(CDC* pDC)
{
	CtestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B

	if(jpgLoadFlag1) {				//tOjpgLoadFlag1̒l"^"o
		img1.Draw(pDC->m_hDC,0,0);  //摜img1̓e\
		jpgLoadFlag1=false;			//tOjpfLoadFlag1"U"ɖ߂
	}

	if(jpgLoadFlag2) {
		img2.Draw(pDC->m_hDC,0,0);
		jpgLoadFlag2=false;
	}

	if(jpgLoadFlag3) {
		img3.Draw(pDC->m_hDC,0,0);
		jpgLoadFlag3=false;
	}

	if(LabFlag) {
		CString Output;				//o̓tH[}bg̒`
		Output.Format(_T("ẍ搔=%d"),Labno); //o͓e̒`
		pDC->TextOut(20+jpgWidth,20,Output);		//o
		LabFlag=false;
	}

	if(CLFlag) {
		CString Output;
		Output.Format(_T("֊sf̐%d"),contn);
		pDC->TextOut(jpgWidth+20, 20, Output);
		Output.Format(_T("֊s̒%f"),contl);
		pDC->TextOut(jpgWidth+20, 50, Output);
		CLFlag=false;
	}

	if(FPFlag) {
		CString Output;
		Output.Format(_T("_̑%d "),nfp);
		pDC->TextOut(jpgWidth+20,20,Output);
		for(int i=1; i<=nfp; i++) {
			Output.Format(_T("(%d)=(%d, %d)"),i,FPTx[i],FPTy[i]);
			pDC->TextOutW(jpgWidth+20,20+30*i,Output);
		}
		FPFlag=false;
	}

	if(CircF) {
		CString Output1, Output2;
		Output1.Format(_T("ʐρ%f"), Area);
		Output2.Format(_T("~`x%f"), Circ);
		pDC->TextOut(jpgWidth+20, 80,Output1);
		pDC->TextOutW(jpgWidth+20, 110,Output2);
		CircF=false;
	}

	if(RLFlag) {
		CString Output;
		for(int k=1; k<=lk; k++) {
			Output.Format(_T("n_Wi%d, %d), I_W(%d, %d)"), LineSx[k], LineSy[k], LineEx[k], LineEy[k]);
			pDC->TextOut(jpgWidth+20,20*k+20,Output);
		}
		RLFlag=false;
	}

	CString Value[10];
	Value[0]="Â";
	Value[1]="Â";
	Value[2]="ʏ̖邳";
	Value[3]="邭";
	Value[4]="邭";
	
	CString Saturation[10];
	Saturation[0]="F̂Ȃ";
	Saturation[1]="F̔";
	Saturation[2]="F̂";
	Saturation[3]="F̂͂肵";
	Saturation[4]="N₩";

	CString Color[14];
	Color[0]="";
	Color[1]="F";
	Color[2]="F";
	Color[3]="";
	Color[4]="";
	Color[5]="";
	Color[6]="";
	Color[7]="";
	Color[8]="F";
	Color[9]="Ԏ";
	Color[10]="";
	Color[11]="DF";
	Color[12]="";

	if(HSVFlag)	{
		CString Output1, Output2,Output3;
		Output1.Format(_T("rv=%d, gv=%d, bv=%d"),rv,gv,bv);
		Output2.Format(_T("H=%f, S=%f, V=%f"),HV,SV,VV);
		Output3.Format(_T("̐F́A%sA%s%słB"),Value[vk],Saturation[sk],Color[hk]);
		pDC->TextOut(jpgWidth+20,10,Output1);
		pDC->TextOut(jpgWidth+20,40,Output2);
		pDC->TextOut(jpgWidth+20,70,Output3);

		HSVFlag=false;
	}

	if(SegFlag) {
		CString Output;
		Output.Format(_T("̈搔=%d"),Segno);
		pDC->TextOut(20+jpgWidth,20,Output);
		SegFlag=false;
	}

	if(EPFlag) {
		CString Output;				//o̓tH[}bg̒`
		Output.Format(_T("[_=%d"),nendp); //o͓e̒`
		pDC->TextOut(20+jpgWidth,20,Output);		//o
		EPFlag=false;
	}
}


// CtestView 

BOOL CtestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ̈
	return DoPreparePrinting(pInfo);
}

void CtestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CtestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}


// CtestView ff

#ifdef _DEBUG
void CtestView::AssertValid() const
{
	CView::AssertValid();
}

void CtestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CtestDoc* CtestView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CtestDoc)));
	return (CtestDoc*)m_pDocument;
}
#endif //_DEBUG


// CtestView bZ[W nh

void CtestView::OnFileOpen() //摜̓ǂݍ
{
	// TODO: ɃR}h nh R[hǉ܂B

	CString filename;
	CFileDialog dlg(true, _T("jpg"), _T("*.jpg"));	//Yjpg̃t@Bo
	if(dlg.DoModal()==IDOK) 	{
		filename=dlg.GetPathName();					//ǂݍ݉摜̃t@B擾
	}	
	BeginWaitCursor();								//}[N\
	img0.Destroy();									//摜img0NA
	img1.Destroy();									//摜img1NA
	img2.Destroy();
	img3.Destroy();
	img0.Load(filename);							//摜ۑp
	img1.Load(filename);							//Ώۉ摜
	img2.Load(filename);							//ǉʂѐ؂o摜ۑ
	img3.Load(filename);
	jpgWidth = img1.GetWidth();						//ʕ擾
	jpgHeight = img1.GetHeight();					//ʍ擾

	if(DispF) {
		jpgLoadFlag1=true;							//摜img1̕\tO"^"ɐݒ
		Invalidate();								//ĕ`惋[`֔
	}
	EndWaitCursor();								//}[N
}

void CtestView::OnFileSaveAs() //\摜̃t@B~
{
	// TODO: ɃR}h nh R[hǉ܂B

	CString filename;

	//t@CĨ_CAOJ
	CFileDialog dlg(false,_T("jpg"),_T("*.jpg"),OFN_HIDEREADONLY |OFN_OVERWRITEPROMPT,
					_T("JPEG Files (*.jpg)|*.jpg|All Files (*.*)|*.*||"));
	if (dlg.DoModal() == IDOK) 	{	//_CAOőI΂ꂽt@C̖O擾
		filename = dlg.GetPathName(); //t@Bݒ
		BeginWaitCursor();			//}[N\

		img1.Save(filename);		//w肳ꂽt@Bŕۑ

		EndWaitCursor();			//}[N
	}
}

void CtestView::OnMonotone() //J[摜̃mg[
{
	// TODO: ɃR}h nh R[hǉ܂B

	float RV,GV,BV;
	BeginWaitCursor();
	
	for(int y=0; y<jpgHeight; y++)  {				//ʂcɑ
		for(int x=0; x<jpgWidth; x++) 	{			//ʂɑ
			COLORREF color=img1.GetPixel(x,y);		//fʒũAhXϊ
			RV=GetRValue(color);					//f̐Ԑo
			GV=GetGValue(color);					//      
			BV=GetBValue(color);					//		
			float Gray=0.3*RV+0.59*GV+0.11*BV;		//mg[
			Mimg[x][y]=Gray;						//mg[摜쐬
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));	//mg[摜
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;							//img1e̕\
		Invalidate();								//ĕ`w
	}
	EndWaitCursor();
}

void CtestView::OnFbinary() //Œ肵lœlB
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();	//}[N\
	float Thresh=128;	//Œ~l

	for(int y=0; y<jpgHeight; y++) {	//ʂcɑ
		for(int x=0; x<jpgWidth; x++) {	//ʂɑ
			if(Mimg[x][y]>Thresh) 	{ //Mimg[x][y]Fmg[摜
				img1.SetPixel(x,y,RGB(255,255,255)); //f
				Bimg1[x][y]=1;		//l摜iɍאȂǂɗpj
				Bimg2[x][y]=1;
			}
			else {
				img1.SetPixel(x,y,RGB(0,0,0)); //f
				Bimg1[x][y]=0;
				Bimg2[x][y]=0;
			}
		}
	}

	jpgLoadFlag1=true; //img1\ݒ
	Invalidate();		//ĕ`
	EndWaitCursor();	//}[N
}


void CtestView::SquareS()//`pCfbNX
{
	mx[0]=0; mx[1]=1; mx[2]=1; mx[3]=0; mx[4]=-1; mx[5]=-1; mx[6]=-1; mx[7]=0; mx[8]=1;
	my[0]=0; my[1]=0; my[2]=-1; my[3]=-1; my[4]=-1; my[5]=0; my[6]=1; my[7]=1; my[8]=1;
}

void CtestView::Color() //F
{
//	Fɂ郉x\
	colr[1]=255; colr[2]=255; colr[3]=0;
	colg[1]=0;   colg[2]=255; colg[3]=255;
	colb[1]=0;   colb[2]=0;   colb[3]=0;

//	mg[ɂ郉x\
/*
	colr[1]=255; colr[2]=180; colr[3]=128;
	colg[1]=255; colg[2]=180; colg[3]=128;
	colb[1]=255; colb[2]=180; colb[3]=128;
*/
	}

void CtestView::OnContour() //֊s摜
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int k;
	int Thresh=1;

	BeginWaitCursor();

	OnFbinary();
	
	for(y=1; y<jpgHeight-1;y++) {
		for(x=1; x<jpgWidth-1; x++) {
			Bimg2[x][y]=0;
			if(Bimg1[x][y]<Thresh) continue;
			for(k=1; k<=8; k++) {  //lA
//			for(k=1; k<=8; k=k+2) {  //WA
				if(Bimg1[x+mx[k]][y+my[k]]<Thresh) {
					Bimg2[x][y]=1;
					break;
				}
			}
		}
	}

	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++) {
			img1.SetPixel(x,y,RGB(0,0,0));
			if(Bimg2[x][y]>=Thresh) {
				img1.SetPixel(x,y,RGB(255,255,255));
			}
		}
	}
	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnFpoint() //֊s̓_o
{
	// TODO: ɃR}h nh R[hǉ܂B

	int temp;
	int h,i,j,k;
	int FFPTx[100], FFPTy[100];//̓__̍W
	
	BeginWaitCursor();

	int Thresh=30;//̓_臒l
//	nfpt=0;//_̑

	Fpoint2();//_o{

	h=0;
	temp=Line(FPTx[1],FPTy[1],FPTx[nfp],FPTy[nfp],FPTx[2],FPTy[2]);
	if(temp>=Thresh) {//ŏ̓_
		h=h+1;
		FFPTx[h]=FPTx[1];
		FFPTy[h]=FPTy[1];
		for(i=-1; i<=1; i++)
			for(j=-1; j<=1; j++)
				img1.SetPixel(FFPTx[h]+i,FFPTy[h]+j,RGB(255,0,0));
	}

	for(k=2; k<=nfp-1; k++) {
		temp=Line(FPTx[k],FPTy[k],FPTx[k-1],FPTy[k-1],FPTx[k+1],FPTy[k+1]);
		if(temp>=Thresh) {
			h=h+1;
			FFPTx[h]=FPTx[k];
			FFPTy[h]=FPTy[k];
			for(i=-1; i<=1; i++)
				for(j=-1; j<=1; j++)
					img1.SetPixel(FFPTx[h]+i,FFPTy[h]+j,RGB(255,0,0));
		}	
	}

	temp=Line(FPTx[nfp],FPTy[nfp],FPTx[nfp-1],FPTy[nfp-1],FPTx[1],FPTy[1]);
	if(temp>=Thresh) { //Ō̓_
		h=h+1;
		FFPTx[h]=FPTx[nfp];
		FFPTy[h]=FPTy[nfp];
		for(i=-1; i<=1; i++)
			for(j=-1; j<=1; j++)
				img1.SetPixel(FFPTx[h]+i,FFPTy[h]+j,RGB(255,0,0));
	}
		
	nfp=h; //ӁFuI
	for(h=1; h<=nfp; h++) {
		FPTx[h]=FFPTx[h];
		FPTy[h]=FFPTy[h];
	}

	FPFlag=true;//_\tO	
	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}


void CtestView::Fpoint2() //_o
{
	int i,j,m,n;
	int tempx,tempy;

	int f[49],g[49],h[49],k[49],p[49],q[49],r[49],s[49]; //ߖTf̎w
	int nnb=49; //ߖT̉f

	COLORREF color;

	nfp=0;//_̐
	FPTx[0]=-1;
	FPTy[0]=-1;
	for(yy=0; yy<jpgHeight; yy++) {
		for(xx=0; xx<jpgWidth; xx++) {
			Bimg1[xx][yy]=0;
		}
	}

	for(i=1; i<=contn; i++) Bimg1[contx[i]][conty[i]]=1;//֊s̏
 
	for(i=1; i<=contn; i++) {
		xx=contx[i];
		yy=conty[i];

		for(j=0; j<nnb; j++) {
			f[j]=Bimg1[xx+m1x[j]][yy+m1y[j]];
			g[j]=Bimg1[xx+m2x[j]][yy+m2y[j]]; //45x]
			h[j]=Bimg1[xx+m3x[j]][yy+m3y[j]]; //90x]
			k[j]=Bimg1[xx+m4x[j]][yy+m4y[j]]; //135x]
			p[j]=Bimg1[xx+m5x[j]][yy+m5y[j]]; //180x]
			q[j]=Bimg1[xx+m6x[j]][yy+m6y[j]]; //225x]
			r[j]=Bimg1[xx+m7x[j]][yy+m7y[j]]; //270x]
			s[j]=Bimg1[xx+m8x[j]][yy+m8y[j]]; //315x]
		}

		m=0;//͂̂P̐v
		n=0;//͂̂P̔zu`Ԍo
		bool Flag2=false;//͂̂P̔zuiAorPсj`Ԍo
		for(j=1; j<=8; j++) { //[_o
			tempx=xx+m1x[j]; 
			tempy=yy+m1y[j];
			if(Bimg1[tempx][tempy]>0) {
				m=m+1;
				if(n>0) Flag2=true;
				n=3;
			}
			n=n-1;
		}
		if(m==1 || m==2 && Flag2) FPTable(); //_P̐}`(pR[i[܂ށj
		if(m==2 && f[1]==1 && f[8]==1) FPTable();
		if(m==2 && f[1]==1 && f[7]==1) FPTable();
		if(m==2 && f[2]==1 && f[8]==1) FPTable();

		if(f[0]==1 && f[1]==0 && f[2]==1 && f[3]==0 && f[4]==0 && f[5]==0 && f[6]==0 && f[7]==1 && f[8]==0 && f[10]==1 && f[11]==0 && f[12]==0 && f[13]==0)	FPTable();//pR[i[_				
		if(g[0]==1 && g[1]==0 && g[2]==1 && g[3]==0 && g[4]==0 && g[5]==0 && g[6]==0 && g[7]==1 && g[8]==0 && g[10]==1 && g[11]==0 && g[12]==0 && g[13]==0)	FPTable();
		if(h[0]==1 && h[1]==0 && h[2]==1 && h[3]==0 && h[4]==0 && h[5]==0 && h[6]==0 && h[7]==1 && h[8]==0 && h[10]==1 && h[11]==0 && h[12]==0 && h[13]==0)	FPTable();
		if(k[0]==1 && k[1]==0 && k[2]==1 && k[3]==0 && k[4]==0 && k[5]==0 && k[6]==0 && k[7]==1 && k[8]==0 && k[10]==1 && k[11]==0 && k[12]==0 && k[13]==0)	FPTable();
		if(p[0]==1 && p[1]==0 && p[2]==1 && p[3]==0 && p[4]==0 && p[5]==0 && p[6]==0 && p[7]==1 && p[8]==0 && p[10]==1 && p[11]==0 && p[12]==0 && p[13]==0)	FPTable();				
		if(q[0]==1 && q[1]==0 && q[2]==1 && q[3]==0 && q[4]==0 && q[5]==0 && q[6]==0 && q[7]==1 && q[8]==0 && q[10]==1 && q[11]==0 && q[12]==0 && q[13]==0)	FPTable();
		if(r[0]==1 && r[1]==0 && r[2]==1 && r[3]==0 && r[4]==0 && r[5]==0 && r[6]==0 && r[7]==1 && r[8]==0 && r[10]==1 && r[11]==0 && r[12]==0 && r[13]==0)	FPTable();
		if(s[0]==1 && s[1]==0 && s[2]==1 && s[3]==0 && s[4]==0 && s[5]==0 && s[6]==0 && s[7]==1 && s[8]==0 && s[10]==1 && s[11]==0 && s[12]==0 && s[13]==0)	FPTable();
		if(f[0]==1 && f[1]==0 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==1 && f[6]==0 && f[7]==1 && f[8]==0 && f[16]==0 && f[17]==0 && f[18]==1)	FPTable();//_QȂ
		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==0 && f[6]==0 && f[7]==1 && f[8]==0 && f[9]==0 && f[10]==0 && f[24]==1)	FPTable();
		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==0 && f[6]==1 && f[7]==0 && f[8]==0 && f[9]==0 && f[10]==0 && f[24]==1)	FPTable();
		if(g[0]==1 && g[1]==0 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==1 && g[6]==0 && g[7]==1 && g[8]==0 && g[16]==0 && g[17]==0 && g[18]==1)	FPTable();//_QȂ
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==0 && g[6]==0 && g[7]==1 && g[8]==0 && g[9]==0 && g[10]==0 && g[24]==1)	FPTable();
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==0 && g[6]==1 && g[7]==0 && g[8]==0 && g[9]==0 && g[10]==0 && g[24]==1)	FPTable();
		if(h[0]==1 && h[1]==0 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==1 && h[6]==0 && h[7]==1 && h[8]==0 && h[16]==0 && h[17]==0 && h[18]==1)	FPTable();//_QȂ
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==0 && h[6]==0 && h[7]==1 && h[8]==0 && h[9]==0 && h[10]==0 && h[24]==1)	FPTable();
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==0 && h[6]==1 && h[7]==0 && h[8]==0 && h[9]==0 && h[10]==0 && h[24]==1)	FPTable();
		if(k[0]==1 && k[1]==0 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==1 && k[6]==0 && k[7]==1 && k[8]==0 && k[16]==0 && k[17]==0 && k[18]==1)	FPTable();//_QȂ
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==0 && k[6]==0 && k[7]==1 && k[8]==0 && k[9]==0 && k[10]==0 && k[24]==1)	FPTable();
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==0 && k[6]==1 && k[7]==0 && k[8]==0 && k[9]==0 && k[10]==0 && k[24]==1)	FPTable();
		if(p[0]==1 && p[1]==0 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==1 && p[6]==0 && p[7]==1 && p[8]==0 && p[16]==0 && p[17]==0 && p[18]==1)	FPTable();//_QȂ
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==0 && p[6]==0 && p[7]==1 && p[8]==0 && p[9]==0 && p[10]==0 && p[24]==1)	FPTable();
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==0 && p[6]==1 && p[7]==0 && p[8]==0 && p[9]==0 && p[10]==0 && p[24]==1)	FPTable();
		if(q[0]==1 && q[1]==0 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==1 && q[6]==0 && q[7]==1 && q[8]==0 && q[16]==0 && q[17]==0 && q[18]==1)	FPTable();//_QȂ
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==0 && q[6]==0 && q[7]==1 && q[8]==0 && q[9]==0 && q[10]==0 && q[24]==1)	FPTable();
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==0 && q[6]==1 && q[7]==0 && q[8]==0 && q[9]==0 && q[10]==0 && q[24]==1)	FPTable();
		if(r[0]==1 && r[1]==0 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==1 && r[6]==0 && r[7]==1 && r[8]==0 && r[16]==0 && r[17]==0 && r[18]==1)	FPTable();//_QȂ
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==0 && r[6]==0 && r[7]==1 && r[8]==0 && r[9]==0 && r[10]==0 && r[24]==1)	FPTable();
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==0 && r[6]==1 && r[7]==0 && r[8]==0 && r[9]==0 && r[10]==0 && r[24]==1)	FPTable();
		if(s[0]==1 && s[1]==0 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==1 && s[6]==0 && s[7]==1 && s[8]==0 && s[16]==0 && s[17]==0 && s[18]==1)	FPTable();//_QȂ
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==0 && s[6]==0 && s[7]==1 && s[8]==0 && s[9]==0 && s[10]==0 && s[24]==1)	FPTable();
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==0 && s[6]==1 && s[7]==0 && s[8]==0 && s[9]==0 && s[10]==0 && s[24]==1)	FPTable();

		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==0 && f[6]==0 && f[7]==1 && f[8]==1 && f[9]==0 && f[10]==0 && f[24]==0)	FPTable();//_Q
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==0 && g[6]==0 && g[7]==1 && g[8]==1 && g[9]==0 && g[10]==0 && g[24]==0)	FPTable();
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==0 && h[6]==0 && h[7]==1 && h[8]==1 && h[9]==0 && h[10]==0 && h[24]==0)	FPTable();
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==0 && k[6]==0 && k[7]==1 && k[8]==1 && k[9]==0 && k[10]==0 && k[24]==0)	FPTable();
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==0 && p[6]==0 && p[7]==1 && p[8]==1 && p[9]==0 && p[10]==0 && p[24]==0)	FPTable();
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==0 && q[6]==0 && q[7]==1 && q[8]==1 && q[9]==0 && q[10]==0 && q[24]==0)	FPTable();
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==0 && r[6]==0 && r[7]==1 && r[8]==1 && r[9]==0 && r[10]==0 && r[24]==0)	FPTable();
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==0 && s[6]==0 && s[7]==1 && s[8]==1 && s[9]==0 && s[10]==0 && s[24]==0)	FPTable();

		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==1 && f[6]==0 && f[7]==0 && f[8]==0 && f[9]==0 && f[10]==0 && f[16]==0 && f[17]==0 && f[18]==1 && f[24]==1) FPTable();//_RȂ
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==1 && g[6]==0 && g[7]==0 && g[8]==0 && g[9]==0 && g[10]==0 && g[16]==0 && g[17]==0 && g[18]==1 && g[24]==1) FPTable();
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==1 && h[6]==0 && h[7]==0 && h[8]==0 && h[9]==0 && h[10]==0 && h[16]==0 && h[17]==0 && h[18]==1 && h[24]==1) FPTable();
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==1 && k[6]==0 && k[7]==0 && k[8]==0 && k[9]==0 && k[10]==0 && k[16]==0 && k[17]==0 && k[18]==1 && k[24]==1) FPTable();
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==1 && p[6]==0 && p[7]==0 && p[8]==0 && p[9]==0 && p[10]==0 && p[16]==0 && p[17]==0 && p[18]==1 && p[24]==1) FPTable();
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==1 && q[6]==0 && q[7]==0 && q[8]==0 && q[9]==0 && q[10]==0 && q[16]==0 && q[17]==0 && q[18]==1 && q[24]==1) FPTable();
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==1 && r[6]==0 && r[7]==0 && r[8]==0 && r[9]==0 && r[10]==0 && r[16]==0 && r[17]==0 && r[18]==1 && r[24]==1) FPTable();
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==1 && s[6]==0 && s[7]==0 && s[8]==0 && s[9]==0 && s[10]==0 && s[16]==0 && s[17]==0 && s[18]==1 && s[24]==1) FPTable();

		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==1 && f[6]==0 && f[7]==0 && f[8]==0 && f[9]==1 && f[10]==0 && f[16]==0 && f[17]==0 && f[18]==1 && f[24]==0 && f[25]==0 && f[26]==0 && f[48]==1) FPTable();//_SȂ
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==1 && g[6]==0 && g[7]==0 && g[8]==0 && g[9]==1 && g[10]==0 && g[16]==0 && g[17]==0 && g[18]==1 && g[24]==0 && g[25]==0 && g[26]==0 && g[48]==1) FPTable();
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==1 && h[6]==0 && h[7]==0 && h[8]==0 && h[9]==1 && h[10]==0 && h[16]==0 && h[17]==0 && h[18]==1 && h[24]==0 && h[25]==0 && h[26]==0 && h[48]==1) FPTable();
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==1 && k[6]==0 && k[7]==0 && k[8]==0 && k[9]==1 && k[10]==0 && k[16]==0 && k[17]==0 && k[18]==1 && k[24]==0 && k[25]==0 && k[26]==0 && k[48]==1) FPTable();
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==1 && p[6]==0 && p[7]==0 && p[8]==0 && p[9]==1 && p[10]==0 && p[16]==0 && p[17]==0 && p[18]==1 && p[24]==0 && p[25]==0 && p[26]==0 && p[48]==1) FPTable();
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==1 && q[6]==0 && q[7]==0 && q[8]==0 && q[9]==1 && q[10]==0 && q[16]==0 && q[17]==0 && q[18]==1 && q[24]==0 && q[25]==0 && q[26]==0 && q[48]==1) FPTable();
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==1 && r[6]==0 && r[7]==0 && r[8]==0 && r[9]==1 && r[10]==0 && r[16]==0 && r[17]==0 && r[18]==1 && r[24]==0 && r[25]==0 && r[26]==0 && r[48]==1) FPTable();
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==1 && s[6]==0 && s[7]==0 && s[8]==0 && s[9]==1 && s[10]==0 && s[16]==0 && s[17]==0 && s[18]==1 && s[24]==0 && s[25]==0 && s[26]==0 && s[48]==1) FPTable();

		if(f[0]==1 && f[1]==1 && f[2]==0 && f[3]==0 && f[4]==0 && f[5]==1 && f[6]==0 && f[7]==0 && f[8]==0 && f[9]==1 && f[10]==0 && f[16]==0 && f[17]==1 && f[18]==0 && f[24]==0 && f[25]==0 && f[26]==0 && f[36]==0 && f[37]==0 && f[38]==1 && f[48]==1) FPTable();//_TȂ
		if(g[0]==1 && g[1]==1 && g[2]==0 && g[3]==0 && g[4]==0 && g[5]==1 && g[6]==0 && g[7]==0 && g[8]==0 && g[9]==1 && g[10]==0 && g[16]==0 && g[17]==1 && g[18]==0 && g[24]==0 && g[25]==0 && g[26]==0 && g[36]==0 && g[37]==0 && g[38]==1 && g[48]==1) FPTable();
		if(h[0]==1 && h[1]==1 && h[2]==0 && h[3]==0 && h[4]==0 && h[5]==1 && h[6]==0 && h[7]==0 && h[8]==0 && h[9]==1 && h[10]==0 && h[16]==0 && h[17]==1 && h[18]==0 && h[24]==0 && h[25]==0 && h[26]==0 && h[36]==0 && h[37]==0 && h[38]==1 && h[48]==1) FPTable();
		if(k[0]==1 && k[1]==1 && k[2]==0 && k[3]==0 && k[4]==0 && k[5]==1 && k[6]==0 && k[7]==0 && k[8]==0 && k[9]==1 && k[10]==0 && k[16]==0 && k[17]==1 && k[18]==0 && k[24]==0 && k[25]==0 && k[26]==0 && k[36]==0 && k[37]==0 && k[38]==1 && k[48]==1) FPTable();
		if(p[0]==1 && p[1]==1 && p[2]==0 && p[3]==0 && p[4]==0 && p[5]==1 && p[6]==0 && p[7]==0 && p[8]==0 && p[9]==1 && p[10]==0 && p[16]==0 && p[17]==1 && p[18]==0 && p[24]==0 && p[25]==0 && p[26]==0 && p[36]==0 && p[37]==0 && p[38]==1 && p[48]==1) FPTable();
		if(q[0]==1 && q[1]==1 && q[2]==0 && q[3]==0 && q[4]==0 && q[5]==1 && q[6]==0 && q[7]==0 && q[8]==0 && q[9]==1 && q[10]==0 && q[16]==0 && q[17]==1 && q[18]==0 && q[24]==0 && q[25]==0 && q[26]==0 && q[36]==0 && q[37]==0 && q[38]==1 && q[48]==1) FPTable();
		if(r[0]==1 && r[1]==1 && r[2]==0 && r[3]==0 && r[4]==0 && r[5]==1 && r[6]==0 && r[7]==0 && r[8]==0 && r[9]==1 && r[10]==0 && r[16]==0 && r[17]==1 && r[18]==0 && r[24]==0 && r[25]==0 && r[26]==0 && r[36]==0 && r[37]==0 && r[38]==1 && r[48]==1) FPTable();
		if(s[0]==1 && s[1]==1 && s[2]==0 && s[3]==0 && s[4]==0 && s[5]==1 && s[6]==0 && s[7]==0 && s[8]==0 && s[9]==1 && s[10]==0 && s[16]==0 && s[17]==1 && s[18]==0 && s[24]==0 && s[25]==0 && s[26]==0 && s[36]==0 && s[37]==0 && s[38]==1 && s[48]==1) FPTable();

	}
}


void CtestView::SquareS2()//`pCfbNXi45x8ɉ]ʒuݒ肷j
{
	m1x[0]=0; m1x[1]=1; m1x[2]=1; m1x[3]=0; m1x[4]=-1; m1x[5]=-1; m1x[6]=-1; m1x[7]=0; m1x[8]=1;
	m1x[9]=2; m1x[10]=2; m1x[11]=2; m1x[12]=1; m1x[13]=0; m1x[14]=-1; m1x[15]=-2; m1x[16]=-2; m1x[17]=-2;
	m1x[18]=-2; m1x[19]=-2; m1x[20]=-1; m1x[21]=0; m1x[22]=1; m1x[23]=2; m1x[24]=2;
	m1x[25]=3; m1x[26]=3; m1x[27]=3; m1x[28]=3; m1x[29]=2; m1x[30]=1; m1x[31]=0; m1x[32]=-1; m1x[33]=-2;
	m1x[34]=-3; m1x[35]=-3; m1x[36]=-3; m1x[37]=-3; m1x[38]=-3; m1x[39]=-3; m1x[40]=-3; m1x[41]=-2; m1x[42]=-1;
	m1x[43]=0; m1x[44]=1; m1x[45]=2; m1x[46]=3; m1x[47]=3; m1x[48]=3;
	m1y[0]=0; m1y[1]=0; m1y[2]=-1; m1y[3]=-1; m1y[4]=-1; m1y[5]=0; m1y[6]=1; m1y[7]=1; m1y[8]=1; 
	m1y[9]=0; m1y[10]=-1; m1y[11]=-2; m1y[12]=-2; m1y[13]=-2; m1y[14]=-2; m1y[15]=-2; m1y[16]=-1; m1y[17]=0;
	m1y[18]=1; m1y[19]=2; m1y[20]=2; m1y[21]=2; m1y[22]=2; m1y[23]=2; m1y[24]=1;
	m1y[25]=0; m1y[26]=-1; m1y[27]=-2; m1y[28]=-3; m1y[29]=-3; m1y[30]=-3; m1y[31]=-3; m1y[32]=-3; m1y[33]=-3;
	m1y[34]=-3; m1y[35]=-2; m1y[36]=-1; m1y[37]=0; m1y[38]=1; m1y[39]=2; m1y[40]=3; m1y[41]=3; m1y[42]=3;
	m1y[43]=3; m1y[44]=3; m1y[45]=3; m1y[46]=3; m1y[47]=2; m1y[48]=1;

	m2x[0]=0; m2x[1]=1; m2x[2]=0; m2x[3]=-1; m2x[4]=-1; m2x[5]=-1; m2x[6]=0; m2x[7]=1; m2x[8]=1; //45x]
	m2x[9]=2; m2x[10]=1; m2x[11]=0; m2x[12]=-1; m2x[13]=-2; m2x[14]=-2; m2x[15]=-2; m2x[16]=-2; m2x[17]=-2; 
	m2x[18]=-1; m2x[19]=0; m2x[20]=1; m2x[21]=2; m2x[22]=2; m2x[23]=2; m2x[24]=2;
	m2x[25]=3; m2x[26]=2; m2x[27]=1; m2x[28]=0; m2x[29]=-1; m2x[30]=-2; m2x[31]=-3; m2x[32]=-3; m2x[33]=-3; 
	m2x[34]=-3; m2x[35]=-3; m2x[36]=-3; m2x[37]=-3; m2x[38]=-2; m2x[39]=-1; m2x[40]=0; m2x[41]=1; m2x[42]=2; 
	m2x[43]=3; m2x[44]=3; m2x[45]=3; m2x[46]=3; m2x[47]=3; m2x[48]=3; 
	m2y[0]=0; m2y[1]=-1; m2y[2]=-1; m2y[3]=-1; m2y[4]=0; m2y[5]=1; m2y[6]=1; m2y[7]=1; m2y[8]=0; 
	m2y[9]=-2; m2y[10]=-2; m2y[11]=-2; m2y[12]=-2; m2y[13]=-2; m2y[14]=-1; m2y[15]=0; m2y[16]=1; m2y[17]=2; 
	m2y[18]=2; m2y[19]=2; m2y[20]=2; m2y[21]=2; m2y[22]=1; m2y[23]=0; m2y[24]=-1;
	m2y[25]=-3; m2y[26]=-3; m2y[27]=-3; m2y[28]=-3; m2y[29]=-3; m2y[30]=-3; m2y[31]=-3; m2y[32]=-2; m2y[33]=-1; 
	m2y[34]=0; m2y[35]=1; m2y[36]=2; m2y[37]=3; m2y[38]=3; m2y[39]=3; m2y[40]=3; m2y[41]=3; m2y[42]=3; 
	m2y[43]=3; m2y[44]=2; m2y[45]=1; m2y[46]=0; m2y[47]=-1; m2y[48]=-2; 

	m3x[0]=0; m3x[1]=0; m3x[2]=-1; m3x[3]=-1; m3x[4]=-1; m3x[5]=0; m3x[6]=1; m3x[7]=1; m3x[8]=1; //90x]
	m3x[9]=0; m3x[10]=-1; m3x[11]=-2; m3x[12]=-2; m3x[13]=-2; m3x[14]=-2; m3x[15]=-2; m3x[16]=-1; m3x[17]=0;
	m3x[18]=1; m3x[19]=2; m3x[20]=2; m3x[21]=2; m3x[22]=2; m3x[23]=2; m3x[24]=1;
	m3x[25]=0; m3x[26]=-1; m3x[27]=-2; m3x[28]=-3; m3x[29]=-3; m3x[30]=-3; m3x[31]=-3; m3x[32]=-3; m3x[33]=-3; 
	m3x[34]=-3; m3x[35]=-2; m3x[36]=-1; m3x[37]=0; m3x[38]=1; m3x[39]=2; m3x[40]=3; m3x[41]=3; m3x[42]=3; 	
	m3x[43]=3; m3x[44]=3; m3x[45]=3; m3x[46]=3; m3x[47]=2; m3x[48]=1; 
	m3y[0]=0; m3y[1]=-1; m3y[2]=-1; m3y[3]=0; m3y[4]=1; m3y[5]=1; m3y[6]=1; m3y[7]=0; m3y[8]=-1; 
	m3y[9]=-2; m3y[10]=-2; m3y[11]=-2; m3y[12]=-1; m3y[13]=0; m3y[14]=1; m3y[15]=2; m3y[16]=2; m3y[17]=2; 
	m3y[18]=2; m3y[19]=2; m3y[20]=1; m3y[21]=0; m3y[22]=-1; m3y[23]=-2; m3y[24]=-2;
	m3y[25]=-3; m3y[26]=-3; m3y[27]=-3; m3y[28]=-3; m3y[29]=-2; m3y[30]=-1; m3y[31]=0; m3y[32]=1; m3y[33]=2; 
	m3y[34]=3; m3y[35]=3; m3y[36]=3; m3y[37]=3; m3y[38]=3; m3y[39]=3; m3y[40]=3; m3y[41]=2; m3y[42]=1; 
	m3y[43]=0; m3y[44]=-1; m3y[45]=-2; m3y[46]=-3; m3y[47]=-3; m3y[48]=-3; 

	m4x[0]=0; m4x[1]=-1; m4x[2]=-1; m4x[3]=-1; m4x[4]=0; m4x[5]=1; m4x[6]=1; m4x[7]=1; m4x[8]=0; //135x]
	m4x[9]=-2; m4x[10]=-2; m4x[11]=-2; m4x[12]=-2; m4x[13]=-2; m4x[14]=-1; m4x[15]=0; m4x[16]=1; m4x[17]=2; 
	m4x[18]=2; m4x[19]=2; m4x[20]=2; m4x[21]=2; m4x[22]=1; m4x[23]=0; m4x[24]=-1;
	m4x[25]=-3; m4x[26]=-3; m4x[27]=-3; m4x[28]=-3; m4x[29]=-3; m4x[30]=-3; m4x[31]=-3; m4x[32]=-2; m4x[33]=-1;
	m4x[34]=0; m4x[35]=1; m4x[36]=2; m4x[37]=3; m4x[38]=3; m4x[39]=3; m4x[40]=3; m4x[41]=3; m4x[42]=3; 
	m4x[43]=3; m4x[44]=2; m4x[45]=1; m4x[46]=0; m4x[47]=-1; m4x[48]=-2;
	m4y[0]=0; m4y[1]=-1; m4y[2]=0; m4y[3]=1; m4y[4]=1; m4y[5]=1; m4y[6]=0; m4y[7]=-1; m4y[8]=-1; 
	m4y[9]=-2; m4y[10]=-1; m4y[11]=0; m4y[12]=1; m4y[13]=2; m4y[14]=2; m4y[15]=2; m4y[16]=2; m4y[17]=2; 
	m4y[18]=1; m4y[19]=0; m4y[20]=-1; m4y[21]=-2; m4y[22]=-2; m4y[23]=-2; m4y[24]=-2;
	m4y[25]=-3; m4y[26]=-2; m4y[27]=-1; m4y[28]=0; m4y[29]=1; m4y[30]=2; m4y[31]=3; m4y[32]=3; m4y[33]=3;
	m4y[34]=3; m4y[35]=3; m4y[36]=3; m4y[37]=3; m4y[38]=2; m4y[39]=1; m4y[40]=0; m4y[41]=-1; m4y[42]=-2; 
	m4y[43]=-3; m4y[44]=-3; m4y[45]=-3; m4y[46]=-3; m4y[47]=-3; m4y[48]=-3;

	m5x[0]=0; m5x[1]=-1; m5x[2]=-1; m5x[3]=0; m5x[4]=1; m5x[5]=1; m5x[6]=1; m5x[7]=0; m5x[8]=-1; //180x]
	m5x[9]=-2; m5x[10]=-2; m5x[11]=-2; m5x[12]=-1; m5x[13]=0; m5x[14]=1; m5x[15]=2; m5x[16]=2; m5x[17]=2;
	m5x[18]=2; m5x[19]=2; m5x[20]=1; m5x[21]=0; m5x[22]=-1; m5x[23]=-2; m5x[24]=-2;
	m5x[25]=-3; m5x[26]=-3; m5x[27]=-3; m5x[28]=-3; m5x[29]=-2; m5x[30]=-1; m5x[31]=0; m5x[32]=1; m5x[33]=2; 
	m5x[34]=3; m5x[35]=3; m5x[36]=3; m5x[37]=3; m5x[38]=3; m5x[39]=3; m5x[40]=3; m5x[41]=2; m5x[42]=1; 
	m5x[43]=0; m5x[44]=-1; m5x[45]=-2; m5x[46]=-3; m5x[47]=-3; m5x[48]=-3; 
	m5y[0]=0; m5y[1]=0; m5y[2]=1; m5y[3]=1; m5y[4]=1; m5y[5]=0; m5y[6]=-1; m5y[7]=-1; m5y[8]=-1; 
	m5y[9]=0; m5y[10]=1; m5y[11]=2; m5y[12]=2; m5y[13]=2; m5y[14]=2; m5y[15]=2; m5y[16]=1; m5y[17]=0; 
	m5y[18]=-1; m5y[19]=-2; m5y[20]=-2; m5y[21]=-2; m5y[22]=-2; m5y[23]=-2; m5y[24]=-1;
	m5y[25]=0; m5y[26]=1; m5y[27]=2; m5y[28]=3; m5y[29]=3; m5y[30]=3; m5y[31]=3; m5y[32]=3; m5y[33]=3; 
	m5y[34]=3; m5y[35]=2; m5y[36]=1; m5y[37]=0; m5y[38]=-1; m5y[39]=-2; m5y[40]=-3; m5y[41]=-3; m5y[42]=-3; 
	m5y[43]=-3; m5y[44]=-3; m5y[45]=-3; m5y[46]=-3; m5y[47]=-2; m5y[48]=-1; 

	m6x[0]=0; m6x[1]=-1; m6x[2]=0; m6x[3]=1; m6x[4]=1; m6x[5]=1; m6x[6]=0; m6x[7]=-1; m6x[8]=-1; //225x]
	m6x[9]=-2; m6x[10]=-1; m6x[11]=0; m6x[12]=1; m6x[13]=2; m6x[14]=2;	m6x[15]=2; m6x[16]=2; m6x[17]=2; 
	m6x[18]=1; m6x[19]=0; m6x[20]=-1; m6x[21]=-2; m6x[22]=-2; m6x[23]=-2; m6x[24]=-2;
	m6x[25]=-3; m6x[26]=-2; m6x[27]=-1; m6x[28]=0; m6x[29]=1; m6x[30]=2; m6x[31]=3; m6x[32]=3; m6x[33]=3; 
	m6x[34]=3; m6x[35]=3; m6x[36]=3; m6x[37]=3; m6x[38]=2; m6x[39]=1; m6x[40]=0; m6x[41]=-1; m6x[42]=-2;
	m6x[43]=-3; m6x[44]=-3; m6x[45]=-3; m6x[46]=-3; m6x[47]=-3; m6x[48]=-3; 
	m6y[0]=0; m6y[1]=1; m6y[2]=1; m6y[3]=1; m6y[4]=0; m6y[5]=-1; m6y[6]=-1; m6y[7]=-1; m6y[8]=0; 
	m6y[9]=2; m6y[10]=2; m6y[11]=2; m6y[12]=2; m6y[13]=2; m6y[14]=1; m6y[15]=0; m6y[16]=-1; m6y[17]=-2; 
	m6y[18]=-2; m6y[19]=-2; m6y[20]=-2; m6y[21]=-2; m6y[22]=-1; m6y[23]=0; m6y[24]=1;
	m6y[25]=3; m6y[26]=3; m6y[27]=3; m6y[28]=3; m6y[29]=3; m6y[30]=3; m6y[31]=3; m6y[32]=2; m6y[33]=1; 
	m6y[34]=0; m6y[35]=-1; m6y[36]=-2; m6y[37]=-3; m6y[38]=-3; m6y[39]=-3; m6y[40]=-3; m6y[41]=-3;m6y[42]=-3; 
	m6y[43]=-3; m6y[44]=-2; m6y[45]=-1; m6y[46]=0; m6y[47]=1; m6y[48]=2; 

	m7x[0]=0; m7x[1]=0; m7x[2]=1; m7x[3]=1; m7x[4]=1; m7x[5]=0; m7x[6]=-1; m7x[7]=-1; m7x[8]=-1; //270x]
	m7x[9]=0; m7x[10]=1; m7x[11]=2; m7x[12]=2;	m7x[13]=2; m7x[14]=2; m7x[15]=2; m7x[16]=1; m7x[17]=0; 
	m7x[18]=-1; m7x[19]=-2; m7x[20]=-2; m7x[21]=-2;	m7x[22]=-2; m7x[23]=-2; m7x[24]=-1; 
	m7x[25]=0; m7x[26]=1; m7x[27]=2; m7x[28]=3; m7x[29]=3; m7x[30]=3; m7x[31]=3; m7x[32]=3; m7x[33]=3; 
	m7x[34]=3; m7x[35]=2; m7x[36]=1; m7x[37]=0; m7x[38]=-1; m7x[39]=-2; m7x[40]=-3; m7x[41]=-3; m7x[42]=-3; 
	m7x[43]=-3; m7x[44]=-3; m7x[45]=-3; m7x[46]=-3; m7x[47]=-2; m7x[48]=-1;
	m7y[0]=0; m7y[1]=1; m7y[2]=1; m7y[3]=0; m7y[4]=-1; m7y[5]=-1; m7y[6]=-1; m7y[7]=0; m7y[8]=1;  
	m7y[9]=2; m7y[10]=2; m7y[11]=2; m7y[12]=1; m7y[13]=0; m7y[14]=-1; m7y[15]=-2; m7y[16]=-2; m7y[17]=-2; 
	m7y[18]=-2; m7y[19]=-2; m7y[20]=-1; m7y[21]=0; m7y[22]=1; m7y[23]=2; m7y[24]=2;
	m7y[25]=3; m7y[26]=3; m7y[27]=3; m7y[28]=3; m7y[29]=2; m7y[30]=1; m7y[31]=0; m7y[32]=-1; m7y[33]=-2; 
	m7y[34]=-3; m7y[35]=-3; m7y[36]=-3; m7y[37]=-3; m7y[38]=-3; m7y[39]=-3; m7y[40]=-3; m7y[41]=-2; m7y[42]=-1; 
	m7y[43]=0; m7y[44]=1; m7y[45]=2; m7y[46]=3; m7y[47]=3; m7y[48]=3;

	m8x[0]=0; m8x[1]=1; m8x[2]=1; m8x[3]=1; m8x[4]=0; m8x[5]=-1; m8x[6]=-1; m8x[7]=-1; m8x[8]=0; //315x]
	m8x[9]=2; m8x[10]=2; m8x[11]=2; m8x[12]=2; m8x[13]=2; m8x[14]=1; m8x[15]=0; m8x[16]=-1; m8x[17]=-2; 
	m8x[18]=-2; m8x[19]=-2; m8x[20]=-2; m8x[21]=-2; m8x[22]=-1; m8x[23]=0; m8x[24]=1;
	m8x[25]=3; m8x[26]=3; m8x[27]=3; m8x[28]=3; m8x[29]=3; m8x[30]=3; m8x[31]=3; m8x[32]=2; m8x[33]=1; 
	m8x[34]=0; m8x[35]=-1; m8x[36]=-2; m8x[37]=-3; m8x[38]=-3; m8x[39]=-3; m8x[40]=-3; m8x[41]=-3; m8x[42]=-3; 
	m8x[43]=-3; m8x[44]=-2; m8x[45]=-1; m8x[46]=0; m8x[47]=1; m8x[48]=2; 
	m8y[0]=0; m8y[1]=1; m8y[2]=0; m8y[3]=-1; m8y[4]=-1; m8y[5]=-1; m8y[6]=0; m8y[7]=1; m8y[8]=1; 
	m8y[9]=2; m8y[10]=1; m8y[11]=0; m8y[12]=-1; m8y[13]=-2; m8y[14]=-2; m8y[15]=-2; m8y[16]=-2; m8y[17]=-2; 
	m8y[18]=-1; m8y[19]=0; m8y[20]=1; m8y[21]=2; m8y[22]=2; m8y[23]=2; m8y[24]=2;
	m8y[25]=3; m8y[26]=2; m8y[27]=1; m8y[28]=0; m8y[29]=-1; m8y[30]=-2; m8y[31]=-3; m8y[32]=-3; m8y[33]=-3; 
	m8y[34]=-3; m8y[35]=-3; m8y[36]=-3; m8y[37]=-3; m8y[38]=-2; m8y[39]=-1; m8y[40]=0; m8y[41]=1; m8y[42]=2; 
	m8y[43]=3; m8y[44]=3; m8y[45]=3; m8y[46]=3; m8y[47]=3; m8y[48]=3; 
}

void CtestView::FPTable() //_̒~
{
	bool TempF=false;//o_ƓꔻtO
	int Thresh=3;//_ƌȂ
	int k;
	for(k=0; k<=nfp; k++) {
		if(max(abs(xx-FPTx[k]),abs(yy-FPTy[k]))<=Thresh) {
			FPTx[k]=xx; //VKD
			FPTy[k]=yy;
			TempF=true;
		}
	}
	if(!TempF) {
		nfp=nfp+1;
		FPTx[nfp]=xx;
		FPTy[nfp]=yy;
	}
}

int CtestView::Line(int x, int y, int p1x, int p1y, int p2x, int p2y)
{
	return(abs((p1x-p2x)*(y-p1y)-(p1y-p2y)*(x-p1x)));
}


void CtestView::OnThinning() //א
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int k;
	int f[9];
	
	BeginWaitCursor();

	OnMonotone();
	OnFbinary();

	bool WFlag=true; //݌otO
	while(WFlag) {
		WFlag=false;

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) {
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==1 && f[3]==0 && f[4]==0 && f[5]==0 && f[7]==1) 		{
					Bimg2[x][y]=0; 	WFlag=true;
				}
			}
		}
		OnTransb21(); //Bimg1Bimg2֓]

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[2]==0 && f[3]==0 && f[4]==0 && f[6]==1 && f[7]==1) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==0 && f[2]==0 && f[3]==0 && f[5]==1 && f[7]==1) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==0 && f[2]==0 && f[4]==1 && f[5]==1 && f[8]==0) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==0 && f[3]==1 && f[5]==1 && f[7]==0 && f[8]==0) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[2]==1 && f[3]==1 && f[6]==0 && f[7]==0 && f[8]==0) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==1 && f[3]==1 && f[5]==0 && f[6]==0 && f[7]==0) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

		for(y=1; y<jpgHeight-1; y++) {
			for(x=1; x<jpgWidth-1; x++) 	{
				if(Bimg1[x][y]==0) continue;
				for(k=1; k<=8; k++) {
					f[k]=Bimg1[x+mx[k]][y+my[k]];
				}
				if(f[1]==1 && f[4]==0 && f[5]==0 && f[6]==0 && f[8]==1) {
					Bimg2[x][y]=0; WFlag=true;
				}
			}
		}
		OnTransb21();

	}

	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++) 	{
			if(Bimg1[x][y]==1) {
				img1.SetPixel(x,y,RGB(255,0,0));
			}
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnTransb21() //img2img1֓]
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++) 	{
			Bimg1[x][y]=Bimg2[x][y];
		}
	}
}


void CtestView::OnCircularity() //~`x
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;

	BeginWaitCursor();

	OnMonotone();
	OnFbinary();

	Area=0;
	for(y=0; y<jpgHeight; y++)
		for(x=0; x<jpgWidth; x++) {
			if(Bimg1[x][y]==0) continue;
			else Area += 1;
		}

	OnContourl();

	Circ=4*3.14*Area/(contl*contl);

	jpgLoadFlag1=true;
	CircF=true;
	Invalidate();
}

void CtestView::OnHough() //ntϊ
{
	// TODO: ɃR}h nh R[hǉ܂B

	int i,j,k;
	int x,y;

	int resol=500; //Ǝ̍ו
	float accmax, accmaxR, accmaxT; //ݐϒl
	float R; //rƖʂł̂l
	float ut=2*3.14/resol; //Ίp̒PʃXebv
	float temp=jpgWidth*jpgWidth+jpgHeight*jpgHeight;
	float shift=sqrt(temp); //rƖʂ𐳒lƂ邽߂̃Vtg

	BeginWaitCursor();

	for(j=0; j<shift*2; j++)
		for(i=0; i<resol; i++)
			RT[i][j]=0; //rƖʁiݐϒlLpj

	accmax=0; //őݐϒl
	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++) {
			if(Bimg1[x][y]==0) continue;
			for(k=0; k<resol; k++) {
				float T=ut*k;
				R=x*cos(T)+y*sin(T)+shift; //ݐϒl̈𐳂Ƃ邽
				int IR=R;
				RT[k][IR]=RT[k][IR]+1;
				if(accmax<RT[k][IR]) {
					accmax=RT[k][IR];
					accmaxR=R; //őݐϒlł̂
					accmaxT=T; //őݐϒlł̃
				}
			}
		}
	}
	if(accmax==0) BFlag=true;
	else {
		aa=cos(accmaxT);
		bb=sin(accmaxT);
		cc=-(accmaxR-shift);

		LineS(aa,bb,cc); //\

		jpgLoadFlag1=true;
		InvalidateRect(NULL);
		EndWaitCursor();
	}
}

void CtestView::LineS(float a, float b, float c)//̕\
{
	int h,k;
	int x,y;

	if(a==0) {
		for(k=1; k<jpgWidth-1; k++) {
			for(h=1; h<=8; h++){
				x=k;
				float fy=-c/b;
				y=fy;
				if(Bimg1[x+mx[h]][y+my[h]]==1) 
					img1.SetPixel(x,y,RGB(255,255,0));
			}
		}
	}

	else if(b==0) {
		for(k=1; k<jpgHeight-1; k++) {
			for(h=1; h<=8; h++){
				float fx=-c/a;
				x=fx;
				y=k;
				if(Bimg1[x+mx[h]][y+my[h]]==1) 
					img1.SetPixel(x,y,RGB(255,255,0));
			}
		}
	}

	else	{
		float grad=-a/b;
		if((grad>=-1)&&(grad<=1)) {
			for(k=1; k<jpgWidth-1; k++)	{
				x=k;
				float fy=grad*k-c/b;
				y=fy;
				if(y>=jpgHeight) continue;
				if(y<=0) continue; 
				for(h=1; h<=8; h++){
					if(Bimg1[x+mx[h]][y+my[h]]==1) 
						img1.SetPixel(x,y,RGB(255,255,0));
				}
			}
		}
		else {
			for(k=1; k<jpgHeight-1; k++)	{
				float fx=(1/grad)*k-c/a;
				x=fx;
				if(x<=0) continue;
				if(x>=jpgWidth) continue;
				y=k;
				for(h=1; h<=8; h++){
					if(Bimg1[x+mx[h]][y+my[h]]==1) 
						img1.SetPixel(x,y,RGB(255,255,0));
				}
			}
		}
	}
}

void CtestView::OnLaplacian() //vVAtB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	OnMonotone();

	for (int y=1; y<jpgHeight-1; y++)  { //vVA
		for (int x=1; x<jpgWidth-1; x++) 	{
			int Gray=(-4*Mimg[x][y]+Mimg[x+1][y]+Mimg[x][y+1]+Mimg[x-1][y]+Mimg[x][y-1])*8;
			if (Gray<0) 	Gray=0;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnAbinary() //ϒllƂl
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();
	float Thresh;

	float RV=0;
	float GV=0;
	float BV=0;
	for(int y=0; y<jpgHeight; y++)  { //ϒlZo
		for(int x=0; x<jpgWidth; x++) 	{
			COLORREF colorref=img1.GetPixel(x,y);
			RV=RV+GetRValue(colorref);
			GV=GV+GetGValue(colorref);
			BV=BV+GetBValue(colorref);
		}
	}
	float temp=jpgWidth*jpgHeight;
	Thresh=(0.3*RV+0.59*GV+0.11*BV)/temp; //ϒll

	for(int y=0; y<jpgHeight; y++) {
		for(int x=0; x<jpgWidth; x++) {
			if(Mimg[x][y]>Thresh) 	{ //Mimg[x][y]Fimg1̃mg[摜
				img1.SetPixel(x,y,RGB(255,255,255));
				Bimg1[x][y]=1;
				Bimg2[x][y]=1;
			}
			else {
				img1.SetPixel(x,y,RGB(0,0,0));
				Bimg1[x][y]=0;
				Bimg2[x][y]=0;
			}
		}
	}

	if(DispF) {
		jpgLoadFlag1=true; //\s
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnSubtraction() //Z
{
	// TODO: ɃR}h nh R[hǉ܂B


	int x,y;

	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++) { //
		for(x=0; x<jpgWidth; x++) { //
			COLORREF color1=img1.GetPixel(x,y); //AhXϊ
			COLORREF color2=img2.GetPixel(x,y); //AhXϊ
			int RV=GetRValue(color1)-GetRValue(color2); //Ԑ̍
			int GV=GetGValue(color1)-GetGValue(color2); //ΐ̍
			int BV=GetBValue(color1)-GetBValue(color2); //̍
			if(RV>255) RV=255;  if(RV<0) RV=0;
			if(GV>255) GV=255;  if(GV<0) GV=0;
			if(BV>255) BV=255;  if(BV<0) BV=0;
			img1.SetPixel(x,y,RGB(RV,GV,BV)); //摜̏
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnProduct() //ωZ
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	for (int y=1; y<jpgHeight-1; y++)  { //X^[ij
		for (int x=1; x<jpgWidth-1; x++) 	{ //X^[ij
			COLORREF color0=img0.GetPixel(x,y); //AhXϊ
			COLORREF color1=img1.GetPixel(x,y); //AhXϊ
			int RV=GetRValue(color1);
			int GV=GetGValue(color1);
			int BV=GetBValue(color1);
			if(RV==255) RV=GetRValue(color0); //ω摜̐Ԑ
			else RV=0;
			if(GV==255) GV=GetGValue(color0); //ω摜̗ΐ
			else GV=0;
			if(BV==255) BV=GetBValue(color0); //ω摜̐
			else BV=0;
			img1.SetPixel(x,y,RGB(RV,GV,BV)); //ω摜̏
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnFile2() //ǉ摜̓ǂݍ
{
	// TODO: ɃR}h nh R[hǉ܂B
	CString filename;

	CFileDialog dlg(true, _T("jpg"), _T("*.jpg"));
	img2.Destroy();

	if(dlg.DoModal()==IDOK) 	{
		filename=dlg.GetPathName();
	}
	
	BeginWaitCursor(); 

	img2.Load(filename);	//ǉʃ

	if(DispF) {
		jpgLoadFlag2=true;
		Invalidate();
	}
	EndWaitCursor();

}

void CtestView::OnLButtonDown(UINT nFlags, CPoint point) //}EX̍{^_Eo
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B

	CView::OnLButtonDown(nFlags, point);

	int i,j;

	px=point.x;
	py=point.y;

	COLORREF color=img1.GetPixel(px,py);
	rv=GetRValue(color);
	gv=GetGValue(color);
	bv=GetBValue(color);
	img1.SetPixel(px, py, RGB(255,0,0));//w_ʒu̐ԓ_\

	for(j=0; j<=20; j++)//w_̐F\
		for(i=0; i<=20; i++)
			img1.SetPixel(jpgWidth-30+i,20+j,RGB(rv,gv,bv));

	jpgLoadFlag1=true;
	InvalidateRect(NULL);
}

void CtestView::OnHsvconv() //RGB->HSVFϊ
{
	// TODO: ɃR}h nh R[hǉ܂B

	Convert(); 

	if(HV>=345) if(HV<=360) hk=0; //ԁi0xj
	if(HV>=0) if(HV<15) hk=0; //ԁi0xj
	if(HV>=15) if(HV<45) hk=1; //i30xj
	if(HV>=45) if(HV<75) hk=2; //Fi60xj
	if(HV>=75) if(HV<105) hk=3; //
	if(HV>=105) if(HV<150) hk=4; //(120xj
	if(HV>=150) if(HV<210) hk=5; //(180xj
	if(HV>=210) if(HV<255) hk=6; //(240xj
	if(HV>=255) if(HV<285) hk=7; //(270xj
	if(HV>=285) if(HV<315) hk=8; //(300xj
	if(HV>=315) if(HV<345) hk=9; //Ԏi330xj

	if(VV>=80) vk=4; //邢
	if(VV<80) if(VV>=60) vk=3; //邢
	if(VV<60) if(VV>=40) vk=2; //ʏ̖邳
	if(VV<40) if(VV>=20) vk=1; //Â
	if(SV>=90) sk=4;//N₩
	if(SV<90) if(SV>=60) sk=3;//F̂͂肵
	if(SV<60) if(SV>=40) sk=2; //F̂
	if(SV<40) if(SV>=20) sk=1; //F̔
	if(SV<20) 
	{
		sk=0; //F̂Ȃ
		if(VV>20) if(VV<=50)	{
			sk=1; hk=11; //ÂDF
		}
		if(VV>50) if(VV<=70)	{
			vk=2; hk=11; //ʏ̖邳̊DF
		}
		if(VV>70) if(VV<90) 	{
			vk=3; hk=11; //邢DF
		}
		if(VV>=90)		{
			vk=4; hk=12; //邢
		}
	}
        
	if(VV<20) {vk=0; sk=0; hk=10;}//ÂF̂Ȃ

	jpgLoadFlag1=true;
	HSVFlag=true;
	Invalidate();
}

void CtestView::Convert()//	RGBFHSVɕϊi{̕j
{
	float NG;

	NG=255;
	float RV=rv/NG;
	float GV=gv/NG;
	float BV=bv/NG;

	VV=max(RV,GV); VV=max(VV,BV);
	float XV=min(RV,GV); XV=min(XV,BV);
	SV=(VV-XV)/VV;

	if(VV==RV)if(XV==GV) HV=(5+(VV-BV)/(VV-XV))*60;
	if(VV==RV)if(XV==BV) HV=(1-(VV-GV)/(VV-XV))*60;
	if(VV==GV)if(XV==BV) HV=(1+(VV-RV)/(VV-XV))*60;
	if(VV==GV)if(XV==RV) HV=(3-(VV-BV)/(VV-XV))*60;
	if(VV==BV)if(XV==RV) HV=(3+(VV-GV)/(VV-XV))*60;
	if(VV==BV)if(XV==GV) HV=(5-(VV-RV)/(VV-XV))*60;
	
	VV=100*VV;
	SV=100*SV;
}

void CtestView::OnCseg() //Fɂ̈敪
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int k;//xԍ
	int RV1,GV1,BV1,RV2,GV2,BV2;
	int g,i;

	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++)//LimgNA
		for(x=0; x<jpgWidth; x++)
			Limg[x][y]=0;

	k=0;
	int xmin=1; 
	int xmax=jpgWidth-2; 
	int ymin=1; 
	int ymax=jpgHeight-2;
	int Difmin=100;
	for(y=ymin; y<=ymax; y++) 	{
		for(x=xmin; x<=xmax; x++) 	{		
			if(Limg[x][y]>0) continue; //xt^ς
			k=k+1;//xԍ
			Limg[x][y]=k;
			Ltab[k]=1;//߂Ă̗̈̉f

			COLORREF colorref=img1.GetPixel(x,y);
			RV1=GetRValue(colorref);
			GV1=GetGValue(colorref);
			BV1=GetBValue(colorref);
			Ctabr[k]=RV1;
			Ctabg[k]=GV1;
			Ctabb[k]=BV1;

			g=1;//xf
			Utabx[g]=x; //ẍ̍W
			Utaby[g]=y;
			while(g>0) { //ɂȂ܂
				int w=Utabx[g]; //PDSoB
				int z=Utaby[g];
				g=g-1;					
				for(i=1; i<=8; i++)		{ //8אډf𒲂ׂ
					if(xmin<=w+mx[i] && w+mx[i]<=xmax && ymin<=z+my[i] && z+my[i]<=ymax) 	{
						if(Limg[w+mx[i]][z+my[i]]==0)   { //x
							COLORREF colorref=img1.GetPixel(w+mx[i],z+my[i]);
							RV2=GetRValue(colorref);
							GV2=GetGValue(colorref);
							BV2=GetBValue(colorref);
							int Dif=abs(Ctabr[k]-RV2)+abs(Ctabg[k]-GV2)+abs(Ctabb[k]-BV2);
							if(Dif>Difmin) 	continue;							
							Limg[w+mx[i]][z+my[i]]=k;
							Ltab[k]=Ltab[k]+1;//xk̗̈̉fv							
							g=g+1;
							Utabx[g]=w+mx[i]; //PDSɏ
							Utaby[g]=z+my[i];
						}
					}
				}			
			}
		}
	}
			
	Segno=k;//̈搔

	for(y=ymin; y<=ymax; y++) {//ʉ摜img1֓]
		for(x=xmin; x<=xmax; x++) 	{
			k=Limg[x][y];
			int tempR=Ctabr[k];
			int tempG=Ctabg[k];
			int tempB=Ctabb[k];
			img1.SetPixel(x,y,RGB(tempR,tempG,tempB));
		}
	}

	SegFlag=true; //̈敪ʕ\tO
	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnMerge() //̈𓝍Tu[`
{
	// TODO: ɃR}h nh R[hǉ܂B

	int delth=200;//ӂɗZ̈̉f̏
	int Sarea=0;//Z鏬̈̐
	int g,h,i,j,k;
	int x,y;
	int tempx;
	int xmin=1;
	int xmax=jpgWidth-2;
	int ymin=1;
	int ymax=jpgHeight-2;

	BeginWaitCursor();

	for(j=1; j<=Segno; j++)	{
		if(Ltab[j]<=delth)		{ //̈̌o
			Sarea=Sarea+1;
			bool ExitFlag=false;
			for(y=ymin; y<=ymax; y++)		{
				for (x=xmin; x<=xmax; x++)		{
					if(Limg[x][y]==j) { //̈̉fo
						ExitFlag=true;
						break;
					}
				}
				if(ExitFlag) break;
			}
			for(tempx=x; tempx<=xmax; tempx++)		{
				if(Limg[tempx][y]==j) continue;
				Limg[x][y]=Limg[tempx][y];// ꃉC㎟̗̈̒lɂB
				break;
			}

			g=1;//xf
			Utabx[g]=x;
			Utaby[g]=y;
			while(g>0) { //ɂȂ܂
				int w=Utabx[g]; //PDSǂ݂
				int z=Utaby[g];
				g=g-1;			
				for(i=1; i<=8; i++)		{
					if(xmin<=w+mx[i] && w+mx[i]<=xmax && ymin<=z+my[i] && z+my[i]<=ymax) 	{
						if(Limg[w+mx[i]][z+my[i]]==j)   { //jxo						
							Limg[w+mx[i]][z+my[i]]=Limg[tempx][y];							
							g=g+1;
							Utabx[g]=w+mx[i]; //PDSɏ
							Utaby[g]=z+my[i];
						}
					}
				}	
			}
		}
	}

	Segno=Segno-Sarea;

	for(y=ymin; y<=ymax; y++) { //ʉ摜img1֓]
		for(x=xmin+1; x<=xmax-1; x++)	{
			k=Limg[x][y];
			int tempR=Ctabr[k];
			int tempG=Ctabg[k];
			int tempB=Ctabb[k];
			img1.SetPixel(x,y,RGB(tempR,tempG,tempB));
		}
	}

	OnCseg(); //̈擝AēxFɂ̈敪sB

	SegFlag=true;
	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnUleft() //_̍W
{
	// TODO: ɃR}h nh R[hǉ܂B

	Lcpx=px;//W
	Lcpy=py;//	    
}

void CtestView::OnLright() //E_̎w
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	Rcpx=px;//EW
	Rcpy=py;//		

	for(y=Lcpy-1; y<=Rcpy+1; y++) {//؂o͈͂𔒐ň͂ށi؂oȂ+-1tj
	    img1.SetPixel(Lcpx-1,y,RGB(255,255,255));
		img1.SetPixel(Rcpx+1,y,RGB(255,255,255));
	}
	for(x=Lcpx-1; x<=Rcpx+1; x++) {
		img1.SetPixel(x,Lcpy-1,RGB(255,255,255));
		img1.SetPixel(x,Rcpy+1,RGB(255,255,255));
	}

	jpgLoadFlag1=true;
	Invalidate();
}

void CtestView::OnCut() //ev[g̐؂o
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	
	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++)
		for(x=0; x<jpgWidth; x++)
			img2.SetPixel(x,y,RGB(0,0,0));

	int xshift=50; //ev[g̃p^[Jnʒu
	int yshift=50;
	for(y=Lcpy; y<=Rcpy; y++) {
		for(x=Lcpx; x<=Rcpx; x++) {
			COLORREF color=img1.GetPixel(x,y);
			int RV=GetRValue(color);
			int GV=GetGValue(color);
			int BV=GetBValue(color);
			img2.SetPixel(x-Lcpx+xshift,y-Lcpy+yshift,RGB(RV,GV,BV));
		}
	}

	xminP=xshift; xmaxP=Rcpx-Lcpx+xshift; //ev[g̃p^[̈ʒu
	yminP=yshift; ymaxP=Rcpy-Lcpy+yshift;

	jpgLoadFlag2=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnPatmatch() //p^[}b`O
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y,i,j;
	int MatPx, MatPy; //}b`O_̍W
	int PHeight=ymaxP-yminP;
	int PWidth=xmaxP-xminP;
	int yPS=0;
	int yPE=jpgHeight-1-PHeight;
	int xPS=0;
	int xPE=jpgWidth-1-PWidth;

	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++) { //Ώۉ摜̃mg[
		for(x=0; x<jpgWidth; x++) {
			COLORREF color=img1.GetPixel(x,y);
			int RV=GetRValue(color);
			int GV=GetGValue(color);
			int BV=GetBValue(color);
			int Gray=0.3*RV+0.59*GV+0.11*BV;
			MonoF[x][y]=Gray;
		}
	}

	for(y=0; y<jpgHeight; y++) { //p^[̃mg[
		for(x=0; x<jpgWidth; x++) {
			COLORREF color=img2.GetPixel(x,y);
			int RV=GetRValue(color);
			int GV=GetGValue(color);
			int BV=GetBValue(color);
			int Gray=0.3*RV+0.59*GV+0.11*BV;
			MonoP[x][y]=Gray;
		}
	}

	float Diff=100000000000;
	for(y=yPS; y<=yPE; y++) {
		for(x=xPS; x<=xPE; x++) {
			float temp=0;
			bool ExitF=false;
			for(j=0; j<=PHeight; j++) {
				for(i=0; i<=PWidth; i++) {
					temp=temp+abs(MonoF[x+i][y+j]-MonoP[xminP+i][yminP+j]);
					if(temp>Diff) {
						ExitF=true;
						break;
					}
				}
				if(ExitF) break;
			}        
			if(temp<Diff) {
				MatPx=x; //}b`OƂꂽ_
				MatPy=y;
				Diff=temp;
			}			
		}
	}

	Lcpx=MatPx;//W
	Lcpy=MatPy;//		
	Rcpx=Lcpx+PWidth;//ExW
	Rcpy=Lcpy+PHeight; //    y

	for(y=Lcpy-1; y<=Rcpy+1; y++) { //}b`O͈͂Ԑň͂
	    img1.SetPixel(Lcpx-1,y,RGB(255,0,0));
		img1.SetPixel(Rcpx+1,y,RGB(255,0,0));
	}
	for(x=Lcpx-1; x<=Rcpx+1; x++) {
		img1.SetPixel(x,Lcpy-1,RGB(255,0,0));
		img1.SetPixel(x,Rcpy+1,RGB(255,0,0));
	}

	jpgLoadFlag1=true;
	Invalidate();	
}

void CtestView::OnLaplacian2() //vVAtB^̕ό`
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	OnMonotone();

	for (int y=1; y<jpgHeight-1; y++)  { //vVA
		for (int x=1; x<jpgWidth-1; x++) 	{
			int Gray=(8*Mimg[x][y]-Mimg[x+1][y]-Mimg[x+1][y-1]-Mimg[x][y-1]-Mimg[x-1][y-1]-Mimg[x-1][y]-Mimg[x-1][y+1]-Mimg[x][y+1]-Mimg[x+1][y+1])*4;
			if (Gray<0) 	Gray=0;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnLaplacian3() //vVAtB^̕ό`
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	OnMonotone();

	for (int y=2; y<jpgHeight-2; y++)  { //vVA
		for (int x=2; x<jpgWidth-2; x++) 	{
			int Gray=(20*Mimg[x][y]+6*Mimg[x+1][y]+6*Mimg[x][y+1]+6*Mimg[x-1][y]+6*Mimg[x][y-1]
			-4*Mimg[x+2][y]-3*Mimg[x+2][y-1]-Mimg[x+2][y-2]-3*Mimg[x+1][y-2]-4*Mimg[x][y-2]-3*Mimg[x-1][y-2]
			-Mimg[x-2][y-2]-3*Mimg[x-2][y-1]-4*Mimg[x-2][y]-3*Mimg[x-2][y+1]-Mimg[x-2][y+2]-3*Mimg[x-1][y+2]
			-4*Mimg[x][y+2]-3*Mimg[x+1][y+2]-Mimg[x+2][y+2]-3*Mimg[x+2][y+1])*4;
			if (Gray<0) 	Gray=0;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnDerivative() //tB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int Gray;
	int k=4; //PxW

	BeginWaitCursor();

	OnMonotone();

	for(y=1; y<jpgHeight; y++) {
		for(x=1; x<jpgWidth; x++) {
			Gray=sqrt(float((Mimg[x-1][y]-Mimg[x][y])*(Mimg[x-1][y]-Mimg[x][y])+(Mimg[x][y-1]-Mimg[x][y])*(Mimg[x][y-1]-Mimg[x][y-1])))*k;
			if(Gray>255) Gray=255;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnAverage() //ϒltB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int k;
	float Gray;
	
	BeginWaitCursor();

	OnMonotone();

	for (y=1; y<jpgHeight-1; y++)  { //ϒl
		for (x=1; x<jpgWidth-1; x++) 	{
			Gray=0;
			for(k=0; k<=8; k++) {
				Gray=Gray+Mimg[x+mx[k]][y+my[k]];
			}
			Gray=Gray/9;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnPrewitt() //vDBbgtB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	float diff[2];

	BeginWaitCursor();

	OnMonotone();

	for (int y=1; y<jpgHeight-1; y++)  { //Prewitt Filter
		for (int x=1; x<jpgWidth-1; x++) 	{
			diff[0]=abs(-Mimg[x+1][y+1]-Mimg[x+1][y]-Mimg[x+1][y-1]
					+Mimg[x-1][y+1]+Mimg[x-1][y]+Mimg[x-1][y-1]); //cGbW
			diff[1]=abs(-Mimg[x+1][y+1]-Mimg[x][y+1]-Mimg[x-1][y+1]
					+Mimg[x-1][y-1]+Mimg[x][y-1]+Mimg[x+1][y-1]); //GbW
			float Gmax=sqrt(diff[0]*diff[0]+diff[1]*diff[1]);
			if(Gmax>255)	Gmax=255;
			img1.SetPixel(x,y,RGB(Gmax,Gmax,Gmax));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnSobel() //\[xtB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	float diff[2];

	BeginWaitCursor();

	OnMonotone();

	for (int y=1; y<jpgHeight-1; y++)  { //Sobel Filter
		for (int x=1; x<jpgWidth-1; x++) 	{
			diff[0]=abs(-Mimg[x+1][y+1]-2*Mimg[x+1][y]-Mimg[x+1][y-1]
					+Mimg[x-1][y+1]+2*Mimg[x-1][y]+Mimg[x-1][y-1]);
			diff[1]=abs(-Mimg[x+1][y+1]-2*Mimg[x][y+1]-Mimg[x-1][y+1]
					+Mimg[x-1][y-1]+2*Mimg[x][y-1]+Mimg[x+1][y-1]);
			float Gmax=sqrt(diff[0]*diff[0]+diff[1]*diff[1]);
			if(Gmax>255)	Gmax=255;
			img1.SetPixel(x,y,RGB(Gmax,Gmax,Gmax));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnMedian() //fBAtB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	int i,j;
	int x,y;
	float Gray;

	BeginWaitCursor();

	OnMonotone();

	for (y=1; y<jpgHeight-1; y++)  { //fBA
		for (x=1; x<jpgWidth-1; x++) 	{
			for (i=0; i<=8; i++)		{
				int m=0; int n=0;
				for (j=0; j<=8; j++) 		{
					if(Mimg[x+mx[i]][y+my[i]]>=Mimg[x+mx[j]][y+my[j]])
						m=m+1;
					if(Mimg[x+mx[i]][y+my[i]]==Mimg[x+mx[j]][y+my[j]])
						n=n+1;
				}

				if(m>=5) {
					if(m-n<5) 	{
						Gray=Mimg[x+mx[i]][y+my[i]];
						img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
						break;
					}
				}
			}
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnSharpen() //stB^
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	OnMonotone();

	for (int y=1; y<jpgHeight-1; y++)  { //s
		for (int x=1; x<jpgWidth-1; x++) 	{
			int Gray=(5*Mimg[x][y]-Mimg[x+1][y]-Mimg[x][y+1]-Mimg[x-1][y]-Mimg[x][y-1]);
			if (Gray<0) 	Gray=0;
			if(Gray>255) Gray=255;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnContourl() //֊sǐ(8Aj
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int i,j,k;
	int stx, sty;//֊sǐՊJnf̍Wl
	int Thresh=1; //l̕~l
	bool Flag=false; //PfotO

	BeginWaitCursor();
	
	contn=0;//֊sf
	contl=0;//֊s̒

	for(y=0; y<jpgHeight; y++)	{ //X^[
		for(x=0; x<jpgWidth; x++)	{
			img1.SetPixel(x,y,RGB(0,0,0));
			if(Flag) continue; //img1
			if(Bimg1[x][y]>=Thresh) { //l摜
				stx=x;  //`Jn_̂W
				sty=y;  //@@@@@@@@
				Flag=true; //img1ʏptO
			}
		}
	}

	j=1;  //֊sf̐
	contx[j]=stx;//ŏ̗֊sf̂W
	conty[j]=sty;
	x=stx; y=sty;
	i=1;
	while(i>0)  {
		if(Bimg1[x+mx[i]][y+my[i]]>=Thresh)  { //UO֏oB
			i=i+1;
			if(i>=9) i=i-8;
			continue;
		}
		break; //O֏oB
	}
	while(i>0)	{
		if(Bimg1[x+mx[i]][y+my[i]]<Thresh) { //֓B
			i=i+1;
			if(i>=9) i=i-8;
			continue;
		}
		x=x+mx[i];
		y=y+my[i];
		j=j+1;
		contx[j]=x;//֊ŝW
		conty[j]=y;//		y
		img1.SetPixel(x,y,RGB(255,255,255));
		contn=contn+1;//֊sf̐
		if(x==contx[j-1] || y==conty[j-1]) contl=contl+1;//֊s̒
		else contl=contl+1.4;//ΊpɌq֊s̒	
		if(x==stx && y==sty) 	break;
		i=i-2;//Oɖ߂
		if(i<1) i=i+8;
	}
	
	jpgLoadFlag1=true;
	CLFlag=true;//֊s\tO
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnBlabeling() //l摜̃xO
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int k;//xԍ
	int g,i,j;

	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++)//ݸ"Limg"NA
		for(x=0; x<jpgWidth; x++) {
			Limg[x][y]=0;	//ݸ؃NA
			img1.SetPixel(x,y,RGB(0,0,0)); //img1NA
		}

	k=0;
	for(y=1; y<jpgHeight-1; y++) 	{	//ʂ̏c
		for(x=1; x<jpgWidth-1; x++) 	{//ʂ̉
			if(Bimg1[x][y]==0) continue; //l摜
			if(Limg[x][y]>0) continue; //xt^ς
			k=k+1;//xԍ
			Limg[x][y]=k;
			img1.SetPixel(x,y,RGB(colr[k],colg[k],colb[k])); //ٗ̈撅F
			Ltab[k]=1;//ٗ̈̉f

			g=1;//xאډf̐
			Utabx[g]=x;	 //אډf̂W
			Utaby[g]=y;  //אډf̂W
			while(g>0) { 
				int w=Utabx[g]; //߯޳؂̎o
				int z=Utaby[g];
				g=g-1;
				for(i=1; i<=8; i++)		{
					if(w+mx[i]>=1 && w+mx[i]<jpgWidth-1 && z+my[i]>=1 && z+my[i]<jpgHeight-1) 	{
						if(Limg[w+mx[i]][z+my[i]]==0)   { //x
							if(Bimg1[w+mx[i]][z+my[i]]==0) continue;					
							Limg[w+mx[i]][z+my[i]]=k;
							img1.SetPixel(w+mx[i],z+my[i],RGB(colr[k],colg[k],colb[k])); //ٗ̈撅F
							Ltab[k]=Ltab[k]+1;//xk̗̈̉fv				
							g=g+1;
							Utabx[g]=w+mx[i]; //߯޳؂ւ̏
							Utaby[g]=z+my[i];
						}
					}
				}		
			}
		}
	}
			
	Labno=k;//ِ

	LabFlag=true; //ݸތʕ\tO
	jpgLoadFlag1=true;
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnNegative() //A̍쐬
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;

	BeginWaitCursor();

	OnMonotone();

	for(y=0; y<jpgHeight; y++)
		for(x=0; x<jpgWidth; x++) {
			COLORREF color=img1.GetPixel(x,y);
			int RV=255-GetRValue(color);
			int GV=255-GetGValue(color);
			int BV=255-GetBValue(color);
			img1.SetPixel(x,y,RGB(RV,GV,BV));
		}

	jpgLoadFlag1=true;
	Invalidate();

	EndWaitCursor();
}

void CtestView::OnSepia() //ZsA摜
{
	// TODO: ɃR}h nh R[hǉ܂B

	float RV,GV,BV;
	BeginWaitCursor();
	
	for(int y=0; y<jpgHeight; y++)  {
		for(int x=0; x<jpgWidth; x++) 	{
			COLORREF colorref=img1.GetPixel(x,y);
			RV=GetRValue(colorref);
			GV=GetGValue(colorref);
			BV=GetBValue(colorref);
			float Gray=0.3*RV+0.59*GV+0.11*BV;
			Mimg[x][y]=Gray;
			img1.SetPixel(x,y,RGB(Gray,Gray*0.7,0));
		}
	}

	jpgLoadFlag1=true; //\s
	Invalidate();
	EndWaitCursor();
}

void CtestView::OnDeresol() //𑜓x
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int i,j;
	float Gray;

	BeginWaitCursor();

	int BlurW=5; //ڂ̕
	int BlurW2=(2*BlurW+1)*(2*BlurW+1);

	for(y=BlurW; y<jpgHeight-BlurW;y++) {
		for(x=BlurW; x<jpgWidth-BlurW; x++) {
			Gray=0;
			for(j=-BlurW; j<=BlurW; j++) {
				for(i=-BlurW; i<=BlurW; i++) {
					Gray=Gray+Mimg[x+i][y+j];
				}
			}
			Gray=Gray/BlurW2;
			Mimg[x][y]=Gray;
			img1.SetPixel(x,y,RGB(Gray,Gray,Gray));
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnFilling() //
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	BeginWaitCursor();

	xwidth=12;//x̖ߕ
	ywidth=12;//y̖ߕ

	Hole2();

	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++)	{
			if(Bimg1[x][y]==1)
			img1.SetPixel(x,y,RGB(255,255,255));
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		InvalidateRect(NULL);
	}
	EndWaitCursor();
}

void CtestView::Hole2() //߁i{́j
{
	bool CFlag=true;//tbO
	int x,y;
	int i,j;

	while(CFlag) {
		CFlag=false;
		for(y=0; y<jpgHeight; y++) {
			for(x=0; x<jpgWidth; x++) {
				if((x-1)>0 && Bimg1[x-1][y]==1 && Bimg1[x][y]==0) {
					for(i=1; i<=xwidth; i++) {
						if(x+i<jpgWidth && Bimg1[x+i][y]==1) {
							Bimg1[x][y]=1;
							CFlag=true;
							break;
						}
					}
				}
				if(Bimg1[x][y]==0 && (y-1)>0 && Bimg1[x][y-1]==1) {
					for(j=1; j<=ywidth; j++) {
						if(y+j<jpgHeight && Bimg1[x][y+j]==1) {
							Bimg1[x][y]=1;
							CFlag=true;
							break;
						}
					}
				}
			}
		}
	}
}

void CtestView::OnEpoint() //[_A_̕\
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	int i,j,k;
	int kk; //Av
	int dot=2; //[_A_̑傫
	int xdef=10; //l
	int ydef=10; //l
	nendp=0; //[_

	BeginWaitCursor();
	
	for(y=ydef; y<jpgHeight-ydef; y++)
		for(x=xdef; x<jpgWidth-xdef; x++) {
			if(Bimg1[x][y]==0) continue;
			kk=0;
			for(k=1; k<=8; k++) {
				if(Bimg1[x+mx[k]][y+my[k]]==1) kk=kk+1;
			}
			if(kk==1) {
				if(y<jpgHeight*3/5) nendp=nendp+1;
				for(j=-dot; j<=dot; j++) 
					for(i=-dot; i<=dot; i++)  {
						img1.SetPixel(x+i,y+j,RGB(0,0,255)); //[_\
					}
			}
			else if(kk==3 || kk==4)
				for(j=-dot; j<=dot; j++) 
					for(i=-dot; i<=dot; i++) 
						img1.SetPixel(x+i,y+j,RGB(0,255,0)); //_A_\
		}

	jpgLoadFlag1=true;
	EPFlag=true; //[_\
	Invalidate();
	EndWaitCursor();

}

void CtestView::OnSequel() //̏o
{
	// TODO: ɃR}h nh R[hǉ܂B

	int k;
	int x,y;
	int klimit=20; //o
	float a,b,c; //ax+by+c=0̌W

	BeginWaitCursor();

	OnFbinary(); //Œjl

	BFlag=false; //ʔtO
	for(k=1; k<=klimit; k++) {
		LineSx[k]=jpgWidth; //n_̂W
		LineSy[k]=jpgHeight;//n_̂W
		LineEx[k]=0;        //I_̂W
		LineEy[k]=0;        //I_̂W

		OnHough();

		if(BFlag) break; //
		lk=k; //o

		DLine(aa, bb, cc); //̏
	}

	RLFlag=true; //o\tO
	jpgLoadFlag1=true;
	InvalidateRect(NULL);
	EndWaitCursor();
}

void CtestView::DLine(float a, float b, float c)//̏
{
	int k;
	float x,y;
	int p,q;
	int Lwidth=2; //̕Б

	if(a==0 && b!=0)
		for(k=0; k<jpgWidth; k++) {
			x=k;
			y=-c/b;
			for(q=y-Lwidth; q<=y+Lwidth; q++) {
				for(p=x-Lwidth; p<=x+Lwidth; p++) {
					if(p<=0 || p>=jpgWidth || q<=0 || q>=jpgHeight) continue;
					if(Bimg1[p][q]==0) continue;
					if(x<LineSx[lk]) LineSx[lk]=x; //n_̂W
					if(x>LineEx[lk]) LineEx[lk]=x; //I_
					LineSy[lk]=y;
					LineEy[lk]=y;
					img1.SetPixel(x,y,RGB(255,0,0)); //d˕\
					Bimg1[p][q]=0;
				}
			}
		}

	else if(a!=0 && b==0)
		for(k=0; k<jpgHeight; k++) {
			x=-c/a;
			y=k;
			for(q=y-Lwidth; q<=y+Lwidth; q++) {
				for(p=x-Lwidth; p<=x+Lwidth; p++) {
					if(p<=0 || p>=jpgWidth || q<=0 || q>=jpgHeight) continue;
					if(Bimg1[p][q]==0) continue;
					LineSx[lk]=x;
					LineEx[lk]=x;
					if(y<LineSy[lk]) LineSy[lk]=y;
					if(y>LineEy[lk]) LineEy[lk]=y;
					img1.SetPixel(x,y,RGB(255,0,0)); //d˕\
					Bimg1[p][q]=0;
				}
			}
		}

	else
	{
		float grad=-a/b;
		if((grad>=-1)&&(grad<=1)) {
			for(k=0; k<jpgWidth; k++)
			{
				x=k;
				y=grad*k-c/b;
				if(y<0) continue;
				if(y>=jpgHeight) continue;
				for(q=y-Lwidth; q<=y+Lwidth; q++) {
					for(p=x-Lwidth; p<=x+Lwidth; p++) {
						if(p<=0 || p>=jpgWidth || q<=0 || q>=jpgHeight) continue;
						if(Bimg1[p][q]==0) continue;
						if(x<LineSx[lk]) {
							LineSx[lk]=x; //n_̂W
							LineSy[lk]=y; //@@@
						}
						if(x>LineEx[lk]) {
							LineEx[lk]=x; //I_̂W
							LineEy[lk]=y; //@@@
						}
						img1.SetPixel(x,y,RGB(255,0,0)); //d˕\
						Bimg1[p][q]=0;
					}
				}
			}
		}
		else {
			for(k=0; k<jpgHeight; k++)
			{
				x=(1/grad)*k-c/a;
				y=k;
				if(x<0) continue;
				if(x>=jpgWidth) continue;
				for(q=y-Lwidth; q<=y+Lwidth; q++) {
					for(p=x-Lwidth; p<=x+Lwidth; p++) {
						if(p<=0 || p>=jpgWidth || q<=0 || q>=jpgHeight) continue;
						if(Bimg1[p][q]==0) continue;
						if(y<LineSy[lk]) {
							LineSy[lk]=y; //n_̂W
							LineSx[lk]=x; //      
						}
						if(y>LineEy[lk]) {
							LineEy[lk]=y; //I_̂W
							LineEx[lk]=x; //@@@
						}
						img1.SetPixel(x,y,RGB(255,0,0)); //d˕\
						Bimg1[p][q]=0;				
					}
				}
			}
		}		
	}
}

void CtestView::OnPress() //^
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	
	BeginWaitCursor();

	for (y=1; y<jpgHeight-1; y++)  { 
		for (x=1; x<jpgWidth-1; x++) 	{
			COLORREF color=img1.GetPixel(x,y);
			int RV=GetRValue(color);
			int GV=GetGValue(color);
			int BV=GetBValue(color);
			if(Bimg1[x][y]>0) img1.SetPixel(x,y,RGB(RV,GV,BV));
			else img1.SetPixel(x,y,RGB(0,0,0));
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnSkin() //̈撊o
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	float HVmin, HVmax, HVmin2, HVmax2, VVmin, VVmax, SVmin, SVmax;
//	HVmin=285; HVmax=360; HVmin2=0; HVmax2=20; SVmin=9; SVmax=50; VVmin=70; VVmax=92;//Ԃ̏
	HVmin=285; HVmax=360; HVmin2=0; HVmax2=20; SVmin=9; SVmax=50; VVmin=20; VVmax=92;//`L

	BeginWaitCursor();

	for(y=0; y<jpgHeight; y++)
		for(x=0; x<jpgWidth; x++)		{
			COLORREF color=img1.GetPixel(x, y);
			rv=GetRValue(color);
			gv=GetGValue(color);
			bv=GetBValue(color);
			
			Convert();// RGBnHVSn֕ϊ

			img3.SetPixel(x,y,RGB(0,0,0));
			if(((HVmin<=HV && HV<=HVmax) || (HVmin2<=HV && HV<=HVmax2)) && VVmin<=VV && VV<=VVmax && SVmin<=SV && SV<=SVmax)	{
				img3.SetPixel(x,y,RGB(rv,gv,bv)); //F̈
			}
		}

	if(DispF) {
		jpgLoadFlag3=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnTrans31() //img3img1֓]
{
	// TODO: ɃR}h nh R[hǉ܂B

	BeginWaitCursor();

	for (int y=1; y<jpgHeight-1; y++)  { //Sobel Filter
		for (int x=1; x<jpgWidth-1; x++) 	{
			COLORREF color3=img3.GetPixel(x,y);
			int RV=GetRValue(color3);
			int GV=GetGValue(color3);
			int BV=GetBValue(color3);
			img1.SetPixel(x,y,RGB(RV,GV,BV));
		}
	}

	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnTrans01() //img0img1֓]
{
	// TODO: ɃR}h nh R[hǉ܂B

	int x,y;
	for(y=0; y<jpgHeight; y++) {
		for(x=0; x<jpgWidth; x++) 	{
			COLORREF color=img0.GetPixel(x,y);
			int RV=GetRValue(color);
			int GV=GetGValue(color);
			int BV=GetBValue(color);
			img1.SetPixel(x,y,RGB(RV,GV,BV));
		}
	}
	if(DispF) {
		jpgLoadFlag1=true;
		Invalidate();
	}
	EndWaitCursor();
}

void CtestView::OnDisp1() //img1\
{
	// TODO: ɃR}h nh R[hǉ܂B

	jpgLoadFlag1=true;
	Invalidate();
}

void CtestView::OnDisp2() //img2\
{
	// TODO: ɃR}h nh R[hǉ܂B

	jpgLoadFlag2=true;
	Invalidate();
}

void CtestView::OnDisp3() //img3\
{
	// TODO: ɃR}h nh R[hǉ܂B

	jpgLoadFlag3=true;
	Invalidate();
}

void CtestView::OnHextract() //lo
{
	// TODO: ɃR}h nh R[hǉ܂B

	DispF=false;

	OnFileOpen();
	OnFile2();
	OnSubtraction();
	OnMonotone();
	OnAbinary();
	OnTrans01();

	DispF=true;
	OnPress();
}

void CtestView::OnTfinger() //w`F
{
	// TODO: ɃR}h nh R[hǉ܂B

	DispF=false;

	OnFileOpen();
	OnSkin();
	OnTrans31();
	OnMonotone();
	OnDeresol();
	OnAbinary();
	OnFilling();
	OnThinning();

	DispF=true;
	OnEpoint();
}
